# Mapping Set: Findex Bau to OpenAlex concepts

This directory contains a mapping set from Findex Bau to [OpenAlex concepts](https://openalex.org/). They were created for an application in [FID BAUdigital's Forschungsatlas](https://forschungsatlas.fid-bau.de/).

They were created applying the [Simple Standard for Sharing Ontology Mappings (SSSOM)](https://mapping-commons.github.io/sssom/home/).

The final mapping set is [/mappings/bau2OpenAlex/bau2OpenAlex%2Bmetadata.ttl](/mappings/bau2OpenAlex/bau2OpenAlex%2Bmetadata.ttl).
The latest version of this mapping set can also be reached via [https://www.purl.org/fidbaudigital/bau2OpenAlex](https://www.purl.org/fidbaudigital/bau2OpenAlex).

In the following all steps applied to produce them will be described.

The current README.md ([/mappings/bau2OpenAlex/README.md](/mappings/bau2OpenAlex/README.md)) can also be reached via [https://www.purl.org/fidbaudigital/bau2OpenAlex/docs](https://www.purl.org/fidbaudigital/bau2OpenAlex/docs).

## File overview

|Output of|Content & Purpose|Location|
|-|-|-|
|[Step 1](#step-1---match-findex-bau-concepts-to-openalex-concepts-via-openalex-api-with-openrefine)|Turtle export from OpenRefine that contains Findex Bau and all potentially matching OpenAlex concepts based on a lexical matching process|[/mappings/bau2OpenAlex/findex-bau-plus-OpenAlex-matches.ttl](/mappings/bau2OpenAlex/findex-bau-plus-OpenAlex-matches.ttl)|
|[Step 2](#step-2---creation-of-specific-mapping-statements-with-sparql-construct-queries)|temporary SPARQL query results, that will be processed in [Step 3](#step-3---setting-up-the-sssom-based-mapping-spreadsheet)|--|
|[Step 3](#step-3---setting-up-the-sssom-based-mapping-spreadsheet)|Spreadsheet containing the original mapping set.|[/mappings/bau2OpenAlex/bau2OpenAlex.sssom.xlsx](/mappings/bau2OpenAlex/bau2OpenAlex.sssom.xlsx)|
|[Step 4](#step-4---mapping-review)|A reviewed version of the mappings. This is the master file for the mapping set. If later reviews require updates, these will be made here. Also new mappings will be added here.|[/mappings/bau2OpenAlex/bau2OpenAlex.sssom.xlsx](/mappings/bau2OpenAlex/bau2OpenAlex.sssom.xlsx)|
|[Step 5](#step-5---creating-tab-seperated-input-for-sssom-tool)|Tab-seperated file with a selection of positive mappings that will serve as the input for the generation of the RDF-based mapping set. It contains only those mappings that (1) are `skos:exactMatch`, (2) do not have the `predicate_modifier` `Not`, and (3) that have a confidence of `> 0.7`|[/mappings/bau2OpenAlex/bau2OpenAlex.sssom.tsv](/mappings/bau2OpenAlex/bau2OpenAlex.sssom.tsv)|
|[Step 6](#step-6---creating-mapping-set-metadata-yml)|Yaml file specifying metadata for the RDF-based mapping set to be generated|[/mappings/bau2OpenAlex/bau2OpenAlex.sssom.yml](/mappings/bau2OpenAlex/bau2OpenAlex.sssom.yml)|
|[Step 7](#step-7---creating-the-tab-seperated-file-with-mappings-and-mapping-set-metadata)|Tab-seperated file generated by `sssom parse` containing the collection of positive mappings and the mapping set metadata|[/mappings/bau2OpenAlex/bau2OpenAlex%2Bmetadata.tsv](/mappings/bau2OpenAlex/bau2OpenAlex%2Bmetadata.tsv)|
|[Step 8](#step-8---converting-tab-seperated-mapping-set-to-rdf-mapping-set)|Turtle representation of the complete mapping set including metadata|[/mappings/bau2OpenAlex/bau2OpenAlex%2Bmetadata.ttl](/mappings/bau2OpenAlex/bau2OpenAlex%2Bmetadata.ttl)|
|[Step 9](#step-9---add-missing-information-to-mappingsbau2openalexbau2openalex2bmetadatattl)|Modified Turtle representation of the complete mapping set including metadata, ontologyIRI, typification of mapping set as owl:Ontology, and typification of all mapping properties as owl:AnnotationProperty|[/mappings/bau2OpenAlex/bau2OpenAlex%2Bmetadata.ttl](/mappings/bau2OpenAlex/bau2OpenAlex%2Bmetadata.ttl)|

## Step 1 - Match Findex Bau concepts to OpenAlex concepts via OpenAlex API with OpenRefine

Automatically declaring a potential match between two vocabularies requires some kind of justification. For example, if both concepts are linked to the same concept from a third vocabulary, this may be a strong indicator that they also share a relation.

Since such a strong indicator was not available for this mapping, a weaker identification trait needed to be found. Since both Findex Bau and OpenAlex declare German and English labels for their concepts, this has been chosen as the basis for a comparison of both resources.

The match between Findex Bau concepts and OpenAlex concepts was therefore based on a concept search on the OpenAlex API.

For each Findex concept's English label a search has been performed and the search results have been fetched. For example, a Findex label could be "built environment" which in a concept search at OpenAlex (<https://api.openalex.org/concepts?search=%22built%20environment%22>) would find the following data belonging to one single concept:

```JSON
{
  "meta": {
    "count": 1,
    "db_response_time_ms": 2,
    "page": 1,
    "per_page": 25
  },
  "results": [
    {
      "id": "https://openalex.org/C148803439",
      "wikidata": "https://www.wikidata.org/wiki/Q4986688",
      "display_name": "Built environment",
      "relevance_score": 7406.235,
      "level": 2,
      "description": "environment created by humans",
      "works_count": 11659,
      "cited_by_count": 180252,
      "ids": {
        "openalex": "https://openalex.org/C148803439",
        "wikidata": "https://www.wikidata.org/wiki/Q4986688",
        "mag": "148803439",
        "wikipedia": "https://en.wikipedia.org/wiki/Built%20environment",
        "umls_cui": [
          "C4505382"
        ]
      },
      "image_url": "https://upload.wikimedia.org/wikipedia/commons/3/37/Suburbia_by_David_Shankbone.jpg",
      "image_thumbnail_url": "https://upload.wikimedia.org/wikipedia/commons/thumb/3/37/Suburbia_by_David_Shankbone.jpg/100px-Suburbia_by_David_Shankbone.jpg",
      "international": {
        "display_name": {
          "ar": "بيئة مبنية",
          "bho": "बनावटी पर्यावरण",
          "bn": "নির্মিত পরিবেশ",
          "bo": "ཁོར་ཡུག་འཛུགས་སྐྲུན།",
          "cs": "vytvořené prostředí",
          "de": "gebaute Umwelt",
          "en": "built environment",
          "eo": "Konstrumedio",
          "es": "ambiente construido",
          "et": "tehiskeskkond",
          "fi": "rakennettu ympäristö",
          "fr": "study and built",
          "hi": "मानव निर्मित पर्यावरण",
          "id": "Lingkungan binaan",
          "ja": "建造環境",
          "pt-br": "ambiente construído",
          "se": "huksejuvvon guovlu",
          "smn": "huksejum kuávlu",
          "sms": "rajjum pirrõs",
          "th": "สิ่งแวดล้อมสรรค์สร้าง",
          "uk": "Техногенне середовище",
          "yue": "建成環境",
          "zh": "建成环境"
        },
        "description": {
          "cs": "člověkem vytvořené životní prostředí",
          "de": "vom Mensch geschaffene Umwelt",
          "en": "environment created by humans",
          "es": "espacios modificados por el ser humano",
          "zh": "人类建造的环境"
        }
      },
      "ancestors": [
        {
          "id": "https://openalex.org/C147176958",
          "wikidata": "https://www.wikidata.org/wiki/Q77590",
          "display_name": "Civil engineering",
          "level": 1
        },
        {
          "id": "https://openalex.org/C18903297",
          "wikidata": "https://www.wikidata.org/wiki/Q7150",
          "display_name": "Ecology",
          "level": 1
        },
        {
          "id": "https://openalex.org/C86803240",
          "wikidata": "https://www.wikidata.org/wiki/Q420",
          "display_name": "Biology",
          "level": 0
        },
        {
          "id": "https://openalex.org/C127413603",
          "wikidata": "https://www.wikidata.org/wiki/Q11023",
          "display_name": "Engineering",
          "level": 0
        }
      ],
      "related_concepts": [
        {
          "id": "https://openalex.org/C49545453",
          "wikidata": null,
          "display_name": "Urban planning",
          "level": 2,
          "score": 5.563681
        },
        {
          "id": "https://openalex.org/C123657996",
          "wikidata": null,
          "display_name": "Architecture",
          "level": 2,
          "score": 4.746209
        },
        {
          "id": "https://openalex.org/C66204764",
          "wikidata": null,
          "display_name": "Sustainability",
          "level": 2,
          "score": 4.669106
        },
        {
          "id": "https://openalex.org/C2777413173",
          "wikidata": null,
          "display_name": "Historic site",
          "level": 2,
          "score": 3.655475
        },
        {
          "id": "https://openalex.org/C205300905",
          "wikidata": null,
          "display_name": "Urban design",
          "level": 3,
          "score": 3.5588348
        },
        {
          "id": "https://openalex.org/C2778368647",
          "wikidata": null,
          "display_name": "Urban area",
          "level": 2,
          "score": 3.109684
        },
        {
          "id": "https://openalex.org/C487182",
          "wikidata": null,
          "display_name": "Urban sprawl",
          "level": 3,
          "score": 2.951421
        },
        {
          "id": "https://openalex.org/C18903297",
          "wikidata": null,
          "display_name": "Ecology",
          "level": 1,
          "score": 2.8537333
        },
        {
          "id": "https://openalex.org/C137355542",
          "wikidata": null,
          "display_name": "World War II",
          "level": 2,
          "score": 2.7424808
        },
        {
          "id": "https://openalex.org/C162324750",
          "wikidata": null,
          "display_name": "Economics",
          "level": 0,
          "score": 2.4815013
        },
        {
          "id": "https://openalex.org/C2780814631",
          "wikidata": null,
          "display_name": "Walkability",
          "level": 3,
          "score": 2.33458
        },
        {
          "id": "https://openalex.org/C132651083",
          "wikidata": null,
          "display_name": "Climate change",
          "level": 2,
          "score": 2.3303614
        },
        {
          "id": "https://openalex.org/C144024400",
          "wikidata": null,
          "display_name": "Sociology",
          "level": 0,
          "score": 2.302181
        },
        {
          "id": "https://openalex.org/C18574340",
          "wikidata": null,
          "display_name": "Environmental psychology",
          "level": 2,
          "score": 2.277088
        },
        {
          "id": "https://openalex.org/C127413603",
          "wikidata": null,
          "display_name": "Engineering",
          "level": 0,
          "score": 2.1044242
        },
        {
          "id": "https://openalex.org/C559116025",
          "wikidata": null,
          "display_name": "Air pollution",
          "level": 2,
          "score": 2.079932
        },
        {
          "id": "https://openalex.org/C4792198",
          "wikidata": null,
          "display_name": "Land use",
          "level": 2,
          "score": 2.0237923
        },
        {
          "id": "https://openalex.org/C147176958",
          "wikidata": null,
          "display_name": "Civil engineering",
          "level": 1,
          "score": 1.9921446
        },
        {
          "id": "https://openalex.org/C2777071753",
          "wikidata": null,
          "display_name": "Urban structure",
          "level": 3,
          "score": 1.1186002
        },
        {
          "id": "https://openalex.org/C2775999810",
          "wikidata": null,
          "display_name": "Allotment",
          "level": 2,
          "score": 0.7903328
        },
        {
          "id": "https://openalex.org/C2781063802",
          "wikidata": null,
          "display_name": "Town centre",
          "level": 2,
          "score": 0.7653771
        }
      ],
      "counts_by_year": [
        {
          "year": 2022,
          "works_count": 797,
          "cited_by_count": 16870
        },
        {
          "year": 2021,
          "works_count": 1243,
          "cited_by_count": 21859
        },
        {
          "year": 2020,
          "works_count": 795,
          "cited_by_count": 18996
        },
        {
          "year": 2019,
          "works_count": 830,
          "cited_by_count": 17320
        },
        {
          "year": 2018,
          "works_count": 815,
          "cited_by_count": 13661
        },
        {
          "year": 2017,
          "works_count": 790,
          "cited_by_count": 13351
        },
        {
          "year": 2016,
          "works_count": 794,
          "cited_by_count": 12460
        },
        {
          "year": 2015,
          "works_count": 722,
          "cited_by_count": 11165
        },
        {
          "year": 2014,
          "works_count": 698,
          "cited_by_count": 10998
        },
        {
          "year": 2013,
          "works_count": 621,
          "cited_by_count": 8964
        },
        {
          "year": 2012,
          "works_count": 575,
          "cited_by_count": 7965
        }
      ],
      "works_api_url": "https://api.openalex.org/works?filter=concepts.id:C148803439",
      "updated_date": "2022-09-15T07:32:41.929307",
      "created_date": "2016-06-24"
    }
  ],
  "group_by": []
}
```

Our search has been limited to English labels since the search only searches in the main `display_name` field* which is reserved for English labels.

In several cases, multiple results were retrieved. This is caused by the fact that findings of terms and phrases in larger phrases are also considered an exact match. For example, a search for "floor" would also match concept labels like _ground floor_ or _floor plan_. Furthermore, multiple results could be retrieved when homonyms are used in the `display_name` field (which we have not encountered so far).

Not all of the retrieved concepts are perfect matches for a Findex Bau concept, even if its English label perfectly matches the OpenAlex display name. We will discuss the pre-processing of the retrieved data in Step 2 and in Step 6.

The retrieval of OpenAlex API search results has been performed with OpenRefine v3.5.2.

First, a project importing the latest version of Findex Bau has been created. At the time of the mapping this was [Release 0.0.1](https://gitlab.com/fid-bau/terminologie/findex-bau/-/releases/0.0.1).

Afterwards, for each Findex Bau concept an OpenAlex search URI has been created from its English skos:prefLabel. The label of the Findex Bau concept has been used as the search query provided to the OpenAlex API.

With this URI the JSON data of potentially matching OpenAlex concepts could be imported into the OpenRefine project where the OpenAlex identifiers have been extracted with a couple of other information, e.g. their German `display_name`, their `description`, their `created_date` and `updated_date` along with linked idenfiers of Wikipedia and Wikidata concepts.

For each retrieved concept, a preliminary relation to the Findex Bau concept has been created, applying `skos:mappingRelation`.

The complete steps to achieve this are documented in the file [/mappings/bau2OpenAlex/OpenRefineProcess.json](/mappings/bau2OpenAlex/OpenRefineProcess.json).

In the end, all statements from Findex Bau including the new, preliminary mapping statements to OpenAlex concepts, have been exported applying an OpenRefine plugin for RDF exports. The applied export schema is defined by [/mappings/bau2OpenAlex/OpenRefineRDFSkeleton.json](/mappings/bau2OpenAlex/OpenRefineRDFSkeleton.json).

The resulting export is [/mappings/bau2OpenAlex/findex-bau-plus-OpenAlex-matches.ttl](/mappings/bau2OpenAlex/findex-bau-plus-OpenAlex-matches.ttl).

Due to homonymy and partial matches, a post-processing to confirm or decline mapping candidates had to be performed in two steps. To reduce the multiplicity of results based on partial string matches between labels, [Step 2](#step-2---creation-of-specific-mapping-statements-with-sparql-construct-queries) has been performed. To decline mappings between distinct concepts that may have been mapped due to homonyms or inappropriate translations in either Findex Bau or OpenAlex, [Step 4](#step-4---mapping-review) has been performed.

## Step 2 - Creation of specific mapping statements with SPARQL CONSTRUCT queries

To reduce the number of potential mappings resulting from partial string matches, we performed a number of SPARQL queries, to generate more specific mapping relations applying `skos:exactMatch`.

Some of these queries rely on assumptions that allow us to have high confidence in the resulting mapping, while others only allow weaker confidence in the resulting mappings.

### SPARQL SELECT query to estimate the number of mapping candidates

At the time of mapping, the API request generated 19.022 mapping candidates (see query below). This is a very high number for the 7.051 Findex Bau concepts that went into the mapping process - each Findex Bau concept has an average of approximately 2.7 mappings (with a range of 1 to 572 mappings). Furtheremore, it is a very high number of mapping candidates to undergo intellectual confirmation by a domain expert.

```SPARQL
PREFIX owl: <http://www.w3.org/2002/07/owl#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
Prefix skos: <http://www.w3.org/2004/02/skos/core#>

SELECT *
WHERE 
{?s skos:mappingRelation ?y} order by ?s
```

Since a lot of mapping candidates have been created due to partial string matches between labels, we performed a number of queries over the RDF-based file exported from OpenRefine.

These queries allowed to declare label comparisons only at exact match, thus reducing the number of mapping candidates to be intellectually evaluated.

The different comparisons allow different (subjective) confidence estimations on the resulting mappings.

Before the queries were conducted, skos:exactMatch needs to be declared as an owl:ObjectProperty in [/mappings/bau2OpenAlex/findex-bau-plus-OpenAlex-matches.ttl](/mappings/bau2OpenAlex/findex-bau-plus-OpenAlex-matches.ttl).

### SPARQL CONSTRUCT queries with results

The numbering of the queries is not in consecutive order, since the queries are presented in a different order here than they were during our process.

#### Query 2 - Englisch and German skos:prefLabel match - high confidence

This query creates a skos:exatMatch between concepts that already have a skos:mappingRelation and additionally have matching German and English skos:preflabels. If two languages to label a concept correspond, we are very confident that the mapping suggestion is correct. The query resulted in 576 skos:exactMatch relations between Findex Bau concepts and OpenAlex concepts.

```SPARQL
PREFIX owl: <http://www.w3.org/2002/07/owl#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
Prefix skos: <http://www.w3.org/2004/02/skos/core#>

construct {?s skos:exactMatch ?y}
#select ?s ?spreflabel ?spreflabel2 ?y ?ypreflabel ?ypreflabel2
where 
{?s skos:mappingRelation ?y. 
?s skos:prefLabel ?spreflabel. 
?y skos:prefLabel ?ypreflabel . 
?s skos:prefLabel ?spreflabel2. 
?y skos:prefLabel ?ypreflabel2. 
Filter (?s != ?y) 
Filter (LANG(?spreflabel) = "de" ) 
Filter (LANG(?ypreflabel) = "de" ) 
Filter (LANG(?spreflabel2) = "en" ) 
Filter (LANG(?spreflabel2) = "en" ) 
Filter (Lcase(str(?spreflabel)) = Lcase(str(?ypreflabel)))
Filter (Lcase(str(?spreflabel2)) = Lcase(str(?ypreflabel2)))
} 
order by ?s
```

Afterwards the concepts that were mapped have been extracted from the RDF file as tabular data with the following query:

```SPARQL
PREFIX owl: <http://www.w3.org/2002/07/owl#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
PREFIX skos: <http://www.w3.org/2004/02/skos/core#>

SELECT (STR(?s) AS ?subject_id) (STR(?sprefde) as ?spref) (STR(?y) AS ?object_id) (str(?yprefde) as ?ypref) (STR(?datec) as?created) (str(?datem) as ?modified)
WHERE
{?s skos:exactMatch ?y.
OPTIONAL {?s skos:prefLabel ?sprefde}
OPTIONAL {?y skos:prefLabel ?yprefde }
FILTER (STRSTARTS(str(?s), "https://terminology" ))
FILTER (LANGMATCHES(LANG(?sprefde), "de"))
FILTER (LANGMATCHES(LANG(?yprefde), "de"))
OPTIONAL {?y <http://purl.org/dc/terms/created> ?datec}
OPTIONAL {?y <http://purl.org/dc/terms/modified> ?datem}
}

ORDER BY ?s
```

#### Query 6 - German skos:prefLabel matches - low confidence

This query creates a skos:exactMatch between concepts that already have a skos:mappingRelation and additionally matching German labels. Since such linguistic comparisons are relatively moot due to lexical ambiguity, we have low confidence that the resulting mappings are correct. All in all, 222 skos:exactMatch relations between Findex Bau concepts and OpenAlex concepts have been created. We exclude here, the results which were already extracted with [Query 2](#query-2---englisch-and-german-skospreflabel-match---high-confidence).

```SPARQL
PREFIX owl: <http://www.w3.org/2002/07/owl#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
Prefix skos: <http://www.w3.org/2004/02/skos/core#>

select *
#construct {?s skos:exactMatch ?y}
where 
{
?s skos:mappingRelation ?y. 
?s skos:prefLabel ?spreflabel. 
?y skos:prefLabel ?ypreflabel. 
FILTER (?s != ?y) 
FILTER (LANG(?spreflabel) = "de" )  
FILTER (LANG(?ypreflabel) = "de" )  
FILTER (LCASE(STR(?spreflabel)) = LCASE(STR(?ypreflabel)))
MINUS {{?s skos:mappingRelation ?y. ?s skos:prefLabel ?spreflabel. ?y skos:prefLabel ?ypreflabel . ?s skos:prefLabel ?spreflabel2. ?y skos:prefLabel ?ypreflabel2. Filter (?s != ?y) Filter (LANG(?spreflabel) = "de" ) Filter (LANG(?ypreflabel) = "de" ) Filter (LANG(?spreflabel2) = "en" ) Filter (LANG(?spreflabel2) = "en" ) Filter (Lcase(str(?spreflabel)) = Lcase(str(?ypreflabel)))Filter (Lcase(str(?spreflabel2)) = Lcase(str(?ypreflabel2)))}}
} 
order by ?s
```

Afterwards the concepts that were mapped have been extracted from the RDF file as tabular data with the following query:

```SPARQL
PREFIX owl: <http://www.w3.org/2002/07/owl#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
PREFIX skos: <http://www.w3.org/2004/02/skos/core#>

SELECT (str(?s) as ?subject_id) (str(?sprefde) as ?spref) (str(?y) as ?object_id) (str(?yprefde) as ?ypref) (str(?datec) as?created) (str(?datem) as ?modified)
WHERE
{?s skos:exactMatch ?y.
OPTIONAL {?s skos:prefLabel ?sprefde}
OPTIONAL {?y skos:prefLabel ?yprefde }
FILTER (STRSTARTS(str(?s), "https://terminology" ))
FILTER (LANGMATCHES(LANG(?sprefde), "de"))
FILTER (LANGMATCHES(LANG(?yprefde), "de"))
OPTIONAL {?y <http://purl.org/dc/terms/created> ?datec}
OPTIONAL {?y <http://purl.org/dc/terms/modified> ?datem}
}

ORDER BY ?s
```

#### Query 7 - English skos:prefLabel matches - low confidence

This query creates a skos:exactMatch between concepts that already have a skos:mappingRelation and additionally have matching English skos:prefLabels. Due to lexial ambiguity we again have low confidence that these mapping suggestions are correct. Furthermore, not all English labels of Findex Bau are appropriate equivalents of the German skos:prefLabel so that we expected mappings created from such a comparison to be less valid than the one created with [Query 6](#query-6---german-skospreflabel-matches---low-confidence). The query resulted in 506 skos:exactMatches between Findex Bau and OpenAlex. We are again excluding results from [Query 2](#query-2---englisch-and-german-skospreflabel-match---high-confidence).

```SPARQL
PREFIX owl: <http://www.w3.org/2002/07/owl#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
Prefix skos: <http://www.w3.org/2004/02/skos/core#>

CONSTRUCT {?s skos:exactMatch ?y}
#SELECT (str(?s) as ?subject_id) (str(?labels) as ?subject_label) (str(?y) as ?object_id) (str(?labely) as ?object_label)
WHERE 
{
?s skos:mappingRelation ?y. 
?s skos:prefLabel ?labels. 
?y skos:prefLabel ?labely. 
Filter (?s != ?y) 
Filter (LANG(?labels) = "en" ) 
Filter (LANG(?labely) = "en" ) 
Filter (LCASE(str(?labels)) = LCASE(str(?labely)))
Minus {{?s skos:mappingRelation ?y. ?s skos:prefLabel ?spreflabel. ?y skos:prefLabel ?ypreflabel . ?s skos:prefLabel ?spreflabel2. ?y skos:prefLabel ?ypreflabel2. Filter (?s != ?y) Filter (LANG(?spreflabel) = "de" ) Filter (LANG(?ypreflabel) = "de" ) Filter (LANG(?spreflabel2) = "en" ) Filter (LANG(?spreflabel2) = "en" ) Filter (Lcase(str(?spreflabel)) = Lcase(str(?ypreflabel)))Filter (Lcase(str(?spreflabel2)) = Lcase(str(?ypreflabel2)))}}
} 
ORDER by ?s
```

Afterwards the concepts that were mapped have been extracted from the RDF file as tabular data with the following query:

```SPARQL
PREFIX owl: <http://www.w3.org/2002/07/owl#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
Prefix skos: <http://www.w3.org/2004/02/skos/core#>

select (str(?s) as ?subject_id) (str(?sprefde) as ?spref) (str(?y) as ?object_id) (str(?yprefde) as ?ypref) (str(?datec) as?created) (str(?datem) as ?modified)
where
{?s skos:exactMatch ?y.
optional {?s skos:prefLabel ?sprefde}
optional {?y skos:prefLabel ?yprefde }
#optional {?s skos:altLabel ?spref}
#optional {?s skos:prefLabel ?spref}
filter (STRSTARTS(str(?s), "https://terminology" ))
filter (LANGMATCHES(LANG(?sprefde), "de"))
filter (LANGMATCHES(LANG(?yprefde), "de"))
optional {?y <http://purl.org/dc/terms/created> ?datec}
optional {?y <http://purl.org/dc/terms/modified> ?datem}
}

order by ?s
```

### SPARQL CONSTRUCT queries without results

The following queries did not yield any results when applied over the OpenRefine export.

#### Query 3  - English and German skos:altLabel match - pretty high confidence

Just as a match of both German and English skos:prefLabels may justify a skos:exactMatch, so do matching German and English skos:altLabels - at least when they are true synonyms of each skos:prefLabel and both skos:prefLabels are good equivalents of each other. This query, however, yielded 0 results.

```SPARQL
PREFIX owl: <http://www.w3.org/2002/07/owl#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
Prefix skos: <http://www.w3.org/2004/02/skos/core#>
select *
where 
{
?s skos:mappingRelation ?y. 
?s skos:altLabel ?saltlabel. 
?y skos:altLabel ?yaltlabel . 
?s skos:altLabel ?saltlabel2. 
?y skos:altLabel ?yaltlabel2. 
Filter (?s != ?y) 
Filter (LANG(?saltlabel) = "de" ) 
Filter (LANG(?yaltlabel) = "de" ) 
Filter (LANG(?saltlabel2) = "en" ) 
Filter (LANG(?yaltlabel2) = "en" ) 
Filter (LCASE(str(?saltlabel)) = LCASE(str(?yaltlabel)))
Filter (LCASE(str(?saltlabel2)) = LCASE(str(?yaltlabel2)))
} order by ?s
```

#### Query 4 - German skos:prefLabel and German skos:altLabel match - high confidence

This query tested whether a German skos:prefLabel of one concept matches to a concept that applies the same label only as a skos:altLabel. It yielded 0 results.

```SPARQL
PREFIX owl: <http://www.w3.org/2002/07/owl#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
Prefix skos: <http://www.w3.org/2004/02/skos/core#>

select *
where 
{
?s skos:mappingRelation ?y. 
?s skos:prefLabel ?spreflabel. 
?y skos:altLabel ?yaltlabel . 
Filter (?s != ?y) 
Filter (LANG(?spreflabel) = "de" ) 
Filter (LANG(?yaltlabel) = "de" )  
filter (LCASE(str(?spreflabel)) = LCASE(str(?yaltlabel)))
} order by ?s
```

#### Query 5 - English skos:prefLabel and English skos:altLabel match - low confidence

This query tested whether an English skos:prefLabel of one concept matches to a concept that applies the same label only as a skos:altLabel. It yielded 0 results. The confidence for the English compariosn is lower as of that of the German comparison, since not all English labels of Findex Bau are the most appropriate equivalent for a German term.

```SPARQL
PREFIX owl: <http://www.w3.org/2002/07/owl#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
Prefix skos: <http://www.w3.org/2004/02/skos/core#>

select *
where 
{
?s skos:mappingRelation ?y. 
?s skos:prefLabel ?spreflabel. 
?y skos:altLabel ?yaltlabel . 
Filter (?s != ?y) 
Filter (LANG(?spreflabel) = "en" ) 
Filter (LANG(?yaltlabel) = "en" )  
filter (LCASE(str(?spreflabel)) = LCASE(str(?yaltlabel)))
} order by ?s
```

#### Query 8 - German skos:altLabel matches - very low confidence

This query tests whether German skos:altLabels matched. Since skos:altLabels sometimes are only near-synonyms we had vry low confidence that the mapping suggestions are correct. The query yielded 0 results.

```SPARQL
PREFIX owl: <http://www.w3.org/2002/07/owl#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
Prefix skos: <http://www.w3.org/2004/02/skos/core#>

select ?s ?saltlabel ?y ?yaltlabel
where 
{
?s skos:mappingRelation ?y. 
?s skos:altLabel ?saltlabel. 
?y skos:altLabel ?yaltlabel. 
Filter (?s != ?y) 
Filter (LANG(?saltlabel) = "de" )  
Filter (LANG(?yaltlabel) = "de" )  
Filter (Lcase(str(?saltlabel)) = LCASE(str(?yaltlabel)))
} 
order by ?s
```

#### Query 9 - English skos:altLabel matches - lowest confidence

This query tests whether English skos:altLabels matched. Since skos:altLabels sometimes are only near-synonyms we had vry low confidence that the mapping suggestions are correct. The query yielded 0 results.

```SPARQL
PREFIX owl: <http://www.w3.org/2002/07/owl#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
Prefix skos: <http://www.w3.org/2004/02/skos/core#>

select ?s ?saltlabel ?y ?yaltlabel
where 
{
?s skos:mappingRelation ?y. 
?s skos:altLabel ?saltlabel. 
?y skos:altLabel ?yaltlabel. 
Filter (?s != ?y) 
Filter (LANG(?saltlabel) = "en" )  
Filter (LANG(?yaltlabel) = "en" )  
Filter (Lcase(str(?saltlabel)) = LCASE(str(?yaltlabel)))
} 
order by ?s
```

## Step 3 - Setting up the SSSOM-based mapping spreadsheet

In Step 3 a spreadsheet with three sheets has been set up, applying colum headers recommended by the [Simple Standard for Sharing Ontology Mappings (SSSOM)](https://mapping-commons.github.io/sssom/home/). These fields are:

`subject_id`, `subject_type`, `subject_label`, `object_id`, `object_type`, `object_label`, `predicate_id`, `predicate_modifier`, `mapping_justification`, `confidence`,  `mapping_date`, `author_id`, `author_label`, `subject_source_version`, `subject_source`, `object_source`, `object_source_version`, `creator_id`,`creator_label`, `reviewer_id`, `reviewer_label`, and `comment`. See the [SSSOM specification 0.10.0](https://mapping-commons.github.io/sssom/) for details.

Additonally, some custom columns have been added to store information. These are:

- `object_source_concept_creation_date (NOT SSSOM)`: The OpenAlex API states the date when a concept was created.
- `mapping_justification_comment NOT SSSOM`: In this column we refer to the number of the query that was applied for the lexical matching process.

The extracted mapping statement information has been added to the different sheets of the table - grouped by query they resulted from. The extraction information corresponds to these SSSOM fields:

|variable|extracted info|SSSOM field|
|-|-|-|
|?subject_id | mapped concept (subejct)|subject_id|
|?spref|German skos:prefLabel of mapped concept (subject)|subject_label|
|?object_id|mapped concept (object)|object_id|
|?ypref|German skos:prefLabel ob mapped concept (object)|object_label|
|?created|creation date of mapped concept (object)|--|
|?modified|modification date of mapped concept (object)|object_source_version|

The other fields have been filled with fitting values for each mapping statement.

Chosen values for empty fields were:

|SSSOM field|SSSOM compatible value|
|-|-|
|`subject_type`|skos concept|
|`object_type`| skos concept|
|`predicate_id`|skos:exactMatch|
|`predicate_modifier`|set to `Not` if the mapping review in [Step 4](#step-4---mapping-review) proved the mapping to be wrong|
|`mapping_justification`|<https://w3id.org/semapv/vocab/LexicalMatching>|
|`confidence`|value from 0 to 1<br>results from query 2 were set to 0.7 <br>results from query 6 were set to 0.3<br> results from query 7 were set to 0.3 |
|`mapping_date`|2022-09-27|
|`author_id`|orcid URI of author|
|`author_label`|first name and last name|
|`subject_source_version`|URI of the GitLab release of Findex Bau that was used during the mapping|
|`subject_source`|URI of the GitLab release of Findex Bau that was used during the mapping|
|`object_source`|identifier of the mapped concept (object), same value as object_id since a versionIRI of OpenAlex concepts is not available|
|`object_source_version`|modification date of each OpenAlex concept as retrieved from the OpenAlex API in the form `2022-09-07T09:12:41.055295`|
|`creator_id`|orcid URI of creator|
|`creator_label`|first name and last name|
|`reviewer_id`|orcid URI of reviewer|
|`reviewer_label`|first name and last name|
|`comment`|individual comments on each mapping statement where skos:exactMatch was not the appropriate relation after review|

## Step 4 - Mapping review

All mapping suggestions have undergone an intellectual review. During this review, the [SSSOM spreadsheet](/mappings/bau2OpenAlex/bau2OpenAlex.sssom.xlsx) has been updated. For example, the predicate_id has been changed where appropriate, review comments have been added and the confidence values have been set higher or lower, where appropriate. Mapping suggestions where none of the skos:mappingRelations was appropriate between the two concepts, have been marked with the `predicate_modifier` value `Not`. The `mapping_justification` value has been set to `https://w3id.org/semapv/vocab/MappingReview`.

## Step 5 - Creating Tab-seperated input for SSSOM tool

The [SSSOM spreadsheet in .xslx](/mappings/bau2OpenAlex/bau2OpenAlex.sssom.xlsx) is a convenient way to perform mapping reviews with domain experts who are not familiar with ontologies and ontology editing tools. As a cloud document, it could also be used very efficiently by several domain experts at the same time.

For further processing with the SSSOM python tools, we need to create a .tsv file of the mappings: [/mappings/bau2OpenAlex/bau2OpenAlex.sssom.tsv](/mappings/bau2OpenAlex/bau2OpenAlex.sssom.tsv).

This file has been created manually and contains mapping statements with predicate `skos:exactMatch` and confidence value `0.9` from [/mappings/bau2OpenAlex/bau2OpenAlex.sssom.xlsx](/mappings/bau2OpenAlex/bau2OpenAlex.sssom.xlsx) and only fields that are SSSOM compliant.

## Step 6 - Creating mapping set metadata (.yml)

The whole mapping set will be published on the GitLab repository of Findex Bau. It should follow FAIR criteria, e.g. containing metadata on the complete mapping set.

In the SSSOM framework, the metadata file additionally contains some information that will be necessary to create an RDF-based resource from the tsv file.

The metadata on mapping set level can be specified in a seperate yaml file: [/mappings/bau2OpenAlex/bau2OpenAlex.sssom.yml](/mappings/bau2OpenAlex/bau2OpenAlex.sssom.yml).

## Step 7 - Creating the tab-seperated file with mappings and mapping set metadata

A complete tsv file can be created with the SSSOM python tools in a command line interface.

In our case:

```bash
sssom parse "bau2OpenAlex.sssom.tsv" -m "bau2OpenAlex.sssom.yml" -o "bau2OpenAlex+metadata.tsv"
```

> The command creates a tsv file that will throw errors in [Step 8](#step-8---converting-tab-seperated-mapping-set-to-rdf-mapping-set). We had to remove the values from mapping set level metadata fields `object_type`, `subject_type`, `object_source`, and `subject_source` to get the sssom convert command in [Step 8](#step-8---converting-tab-seperated-mapping-set-to-rdf-mapping-set) working. Since this information is provided by each mapping statement, this is not a loss of information.

## Step 8 - Converting tab-seperated mapping set to RDF-mapping set

In this step, the table resulting from [Step 7](#step-7---creating-the-tab-seperated-file-with-mappings-and-mapping-set-metadata) will be converted into an RDF file containing the complete mapping set including mapping set level metadata and with reified mapping statements: each mapping statement is identified by a blank node and typed as an owl:Axiom.

In our case:

```bash
sssom convert "bau2OpenAlex+metadata.tsv" -o "bau2OpenAlex+metadata.ttl" --output-format ttl
```

Alternatively, a json-ld file can be created.

```bash
sssom convert "bau2OpenAlex+metadata.tsv" -o "bau2OpenAlex+metadata.json" --output-format json
```

## Step 9 - Add missing information to [/mappings/bau2OpenAlex/bau2OpenAlex%2Bmetadata.ttl](/mappings/bau2OpenAlex/bau2OpenAlex%2Bmetadata.ttl)

The generated file [/mappings/bau2OpenAlex/bau2OpenAlex%2Bmetadata.ttl](/mappings/bau2OpenAlex/bau2OpenAlex%2Bmetadata.ttl) lacks

- an ontologyIRI (even though a mapping_set_id is declared in [the metadata file of mapping set](/mappings/bau2OpenAlex/bau2OpenAlex.sssom.yml),
- typification as an owl:Ontology (the mapping set is automatically declared as [sssom:MappingSet](https://w3id.org/sssom/MappingSet),
- the properties used to describe mappings are not explicitly typed in the mapping set.

Since we want to use the mapping set in an owl:impports statement with Findex Bau, there are a couple of advantages to add this information:

- adding a PURL as the ontologyIRI enables us to load the mapping set from the web even if we need to change its location,
- declaring the mapping set to be an owl:Ontology is convenient when loading the mapping set with Protégé: the mapping set metadata will be displayed in the `Active ontology` tab
- explicitly typing the properties used in mappings via owl:imports of the used vocabularies/ schemas SKOS, SEMAPV and SSSOM schema. 

The following statements needs to be added to [/mappings/bau2OpenAlex/bau2OpenAlex%2Bmetadata.ttl](/mappings/bau2OpenAlex/bau2OpenAlex%2Bmetadata.ttl):

```Turtle
@base <https://www.purl.org/fidbaudigital/bau2OpenAlex> .

<https://www.purl.org/fidbaudigital/bau2OpenAlex> a owl:Ontology, sssom:MappingSet ;
  owl:imports skos: , <https://raw.githubusercontent.com/mapping-commons/sssom/master/project/owl/sssom_schema.owl.ttl>, <https://raw.githubusercontent.com/mapping-commons/semantic-mapping-vocabulary/main/semapv.owl> ;
  owl:versionIRI <https://gitlab.com/fid-bau/terminologie/findex-bau/-/raw/0.0.5/mappings/bau2OpenAlex/bau2OpenAlex+metadata.ttl> .

dcterms:creator a owl:AnnotationProperty. 
dcterms:description a owl:AnnotationProperty.
dcterms:license a owl:AnnotationProperty.
owl:versionInfo a owl:AnnotationProperty.
pav:authoredBy a owl:AnnotationProperty.
pav:authoredOn a owl:AnnotationProperty.
pav:authoredOn a owl:AnnotationProperty.
rdfs:comment a owl:AnnotationProperty.
rdfs:comment a owl:AnnotationProperty.
```

## External Resources

- [SSSOM tutorial](https://mapping-commons.github.io/sssom/tutorial/)
- [SSSOM data model specifiation](https://mapping-commons.github.io/sssom/)
- [SSSOM GitHub repository](https://github.com/mapping-commons/sssom/)
- [SSSOM-Py command line interface documentation](https://mapping-commons.github.io/sssom-py/index.html)
- [Semantic Mapping Vocabulary (SEMAPV)](https://mapping-commons.github.io/semantic-mapping-vocabulary/)
- [SSSOM Schema (owl)](https://github.com/mapping-commons/sssom/blob/master/project/owl/sssom_schema.owl.ttl)

## Endnotes

\* This information is based on our search at 2022-09-12 where OpenAlex was still in a beta stage.
